#ifndef GL_ES
//#define highp
#define mediump
#define lowp
#endif


//precision mediump float;

// vb attribute
attribute mediump vec4 POSITION; 
attribute mediump vec2 TEXCOORD0;

// vb output
varying mediump vec2 texcoord0;
varying mediump vec2 texcoord1; 

// parameter
uniform mediump mat4 matrixMVP;
uniform lowp vec4 color; 

// uv偏移，分量为(u偏移量,v偏移量,每一块占用整个图片的u比例，每一块占用真个图片的v比例)
uniform lowp mat4 param;

void main()
{	
	// 默认vs采取默认操作，位置变换，uv输出
	mediump vec4 out_pos = matrixMVP * POSITION;
	// 把z值拍扁成一层
	out_pos.z = matrixMVP[3].z;
	gl_Position = out_pos;
	
	// mask使用的uv用源图的， 但需要考虑自身转过pvr的缩放  
	//使用maskBoundUVoffset对TEXCOORD1进行uv偏移
	texcoord1 = vec2(param[3].x + TEXCOORD0.x * param[1].z, param[3].y + TEXCOORD0.y * param[1].w);
	
	// 使用uvoffset对TEXCOORD0进行uv偏移
	texcoord0 = vec2(param[0].x + TEXCOORD0.x * param[0].z, param[0].y + TEXCOORD0.y * param[0].w);
}