#ifndef GL_ES
//#define highp
#define mediump
#define lowp
#endif


//precision mediump float;

// vb attribute
attribute mediump vec4 POSITION; 
attribute mediump vec2 TEXCOORD0;

// vb output
varying mediump vec2 texcoord0;
varying mediump vec2 texcoord1; 

// parameter
uniform mediump mat4 matrixMVP;
uniform lowp vec4 color; 

// uv偏移，分量为(u偏移量,v偏移量,每一块占用整个图片的u比例，每一块占用真个图片的v比例)
uniform lowp mat4 param;

void main()
{	
	// 默认vs采取默认操作，位置变换，uv输出
	mediump vec4 out_pos = matrixMVP * POSITION;
	// 把z值拍扁成一层
	out_pos.z = matrixMVP[3].z;
	gl_Position = out_pos;
	
	//先对TEXCOORD0进行旋转
	//先 -(0.5,0.5)到中心
	texcoord1 = vec2(TEXCOORD0.x - 0.5,TEXCOORD0.y - 0.5);
	//旋转角度
	mediump float anglesin = sin(param[3].w);
	mediump float anglecos = cos(param[3].w);
	texcoord1 = vec2(texcoord1.x * anglecos - texcoord1.y * anglesin, texcoord1.x * anglesin + texcoord1.y * anglecos );
	//+(0.5,0.5)还原
	texcoord1 = vec2(texcoord1.x + 0.5,texcoord1.y + 0.5);
	
	
	// mask使用的uv用源图的， 但需要考虑自身转过pvr的缩放  
	//使用maskBoundUVoffset对TEXCOORD1进行uv偏移
	texcoord1 = vec2(param[3].x + texcoord1.x * param[1].z, param[3].y + texcoord1.y * param[1].w);
	//texcoord1 = vec2(param[3].x + TEXCOORD0.x * param[1].z, param[3].y + TEXCOORD0.y * param[1].w);
	
	// 使用uvoffset对TEXCOORD0进行uv偏移	
	texcoord0 = vec2(param[0].x + TEXCOORD0.x * param[0].z, param[0].y + TEXCOORD0.y * param[0].w);
	
	
}